Package org.kie.api.builder

# Interface KieScanner

public interface KieScanner
A KieScanner is a scanner of the maven repositories (both local and remote) used to automatically discover if there are new releases for a given KieModule and its dependencies and eventually deploy them in the KieRepository

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Interface
  Description
  `static enum`
  `KieScanner.Status`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `addListener(KieScannerEventListener listener)`
  Add an event listener.
  `Collection<KieScannerEventListener>`
  `getListeners()`
  Returns all event listeners.
  `void`
  `removeListener(KieScannerEventListener listener)`
  Remove an event listener.
  `void`
  `scanNow()`
  Triggers a synchronous scan
  `void`
  `shutdown()`
  Shuts down the scanner and releases any resources held.
  `void`
  `start(long pollingInterval)`
  Starts this KieScanner polling the maven repositories with the given interval expressed in milliseconds throws An IllegalStateException if this KieScanner has been already started
  `void`
  `stop()`
  Stops this KieScanner, but does not release the resources.

- ## Method Details

  - ### start

    void start(long pollingInterval)
    Starts this KieScanner polling the maven repositories with the given interval expressed in milliseconds throws An IllegalStateException if this KieScanner has been already started

  - ### stop

    void stop()
    Stops this KieScanner, but does not release the resources. A call to `start(long)` will resume the scanner's work after a call to `stop()`

  - ### shutdown

    void shutdown()
    Shuts down the scanner and releases any resources held. After a shutdown call, any call to start() will fail with an exception.

  - ### scanNow

    void scanNow()
    Triggers a synchronous scan

  - ### addListener

    void addListener(KieScannerEventListener listener)
    Add an event listener.
    Parameters:
      `listener` - The listener to add.

  - ### removeListener

    void removeListener(KieScannerEventListener listener)
    Remove an event listener.
    Parameters:
      `listener` - The listener to remove.

  - ### getListeners

    Collection<KieScannerEventListener> getListeners()
    Returns all event listeners.
    Returns:
      listeners The listeners.